
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "vertex.h"

using namespace p3ga;

vertex::vertex() {
}

vertex::vertex(const normalizedPoint &pt, const plane &pl, const mv::Float uv[2]) :
	m_pt(pt), m_pl(pl) {
	m_uv[0] = uv[0];
	m_uv[1] = uv[1];
}

vertex::vertex(const vertex &v) :
	m_pt(v.m_pt), m_pl(v.m_pl) {
	m_uv[0] = v.m_uv[0];
	m_uv[1] = v.m_uv[1];
}

vertex::~vertex() {
}

vertex &vertex::operator=(const vertex &v) {
	if (this != &v) {
		m_pt = v.m_pt;
		m_pl = v.m_pl;
		m_uv[0] = v.m_uv[0];
		m_uv[1] = v.m_uv[1];
	}
	return *this;
}

