
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#ifndef _VERTEX_H_
#define _VERTEX_H_

#include "classes.h"

class vertex {
public:
	vertex(); ///< null constructor
	vertex(const p3ga::normalizedPoint &pt, const p3ga::plane &pl, const p3ga::mv::Float uv[2]); ///< constructor; sets all data of the vertex
	vertex(const vertex &v); ///< copy constructor
	~vertex(); ///< destructor

	vertex &operator=(const vertex &v); ///< copy operator

	/// retrieves m_pt
	inline const p3ga::normalizedPoint &get_pt() const {return m_pt;} 
	/// retrieves m_att
	inline const p3ga::plane &get_pl() const {return m_pl;}
	/// retrieves m_tex_pt
	inline const p3ga::mv::Float *get_tex_uv() const {return m_uv;}

private:
	p3ga::normalizedPoint m_pt; // point in homogenous model
	p3ga::plane m_pl; // plane in homogenous model (tangent plane)
	p3ga::mv::Float m_uv[2];	// uv texture coordinates
};

#endif /* _VERTEX_H_ */

