
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include <math.h>

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif

#include <GL/gl.h>

#include "c3ga_util.h"
#include "p3la.h"

void conformal_TSR_versor_to_P3LA(const c3ga &TSR, p3la_tm &M) {
	// extract rotation
	c3ga ie1 = TSR * (c3ga::e1 ^ c3ga::ni) / TSR; // ie1 = image of e1 ^ ni
	c3ga ie2 = TSR * (c3ga::e2 ^ c3ga::ni) / TSR; // ie2 = image of e2 ^ ni
	c3ga ie3 = TSR * (c3ga::e3 ^ c3ga::ni) / TSR; // ie3 = image of e3 ^ ni
	c3ga ino = TSR * (c3ga::no ^ c3ga::ni) / TSR; // ino = image of no ^ ni

	M.m11 = ie1[GRADE2][C3GA_E1_NI]; M.m21 = ie1[GRADE2][C3GA_E2_NI]; M.m31 = ie1[GRADE2][C3GA_E3_NI]; M.m41 = ie1[GRADE2][C3GA_NO_NI];
	M.m12 = ie2[GRADE2][C3GA_E1_NI]; M.m22 = ie2[GRADE2][C3GA_E2_NI]; M.m32 = ie2[GRADE2][C3GA_E3_NI]; M.m42 = ie2[GRADE2][C3GA_NO_NI];
	M.m13 = ie3[GRADE2][C3GA_E1_NI]; M.m23 = ie3[GRADE2][C3GA_E2_NI]; M.m33 = ie3[GRADE2][C3GA_E3_NI]; M.m43 = ie3[GRADE2][C3GA_NO_NI];
	M.m14 = ino[GRADE2][C3GA_E1_NI]; M.m24 = ino[GRADE2][C3GA_E2_NI]; M.m34 = ino[GRADE2][C3GA_E3_NI]; M.m44 = ino[GRADE2][C3GA_NO_NI];
}



