
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#include "../icons/camera_fov.h"
#include "../icons/camera_translate_orthogonal.h"
#include "../icons/scale.h"
#include "../icons/translate_orthogonal.h"
#include "../icons/camera_orbit.h"
#include "../icons/camera_translate_parallel.h"
#include "../icons/Select.h"
#include "../icons/translate_parallel.h"
#include "../icons/camera_rotate.h"
#include "../icons/rotate.h"
#include "../icons/spotlight.h"

#include "pngfe.h"
#include "icons.h"


namespace { // anonymous namespace
struct png_image_data {
	png_image_data(const unsigned char *_data, int _length) : data(_data), length(_length) {
	}
	
	const unsigned char *data;
	int length;
};
	
struct png_image_data get_icon_png(const std::string &name) {
	if (name == "camera_fov") return png_image_data(camera_fov::data, camera_fov::dataLength);
	else if (name == "camera_translate_orthogonal") return png_image_data(camera_translate_orthogonal::data, camera_translate_orthogonal::dataLength);
	else if (name == "scale") return png_image_data(scale::data, scale::dataLength);
	else if (name == "translate_orthogonal") return png_image_data(translate_orthogonal::data, translate_orthogonal::dataLength);
	else if (name == "camera_orbit") return png_image_data(camera_orbit::data, camera_orbit::dataLength);
	else if (name == "camera_translate_parallel") return png_image_data(camera_translate_parallel::data, camera_translate_parallel::dataLength);
	else if (name == "select") return png_image_data(Select::data, Select::dataLength);
	else if (name == "translate_parallel") return png_image_data(translate_parallel::data, translate_parallel::dataLength);
	else if (name == "camera_rotate") return png_image_data(camera_rotate::data, camera_rotate::dataLength);
	else if (name == "rotate") return png_image_data(rotate::data, rotate::dataLength);
	else if (name == "spotlight") return png_image_data(spotlight::data, spotlight::dataLength);
	else throw std::string("Could not find icon " + name);
}
} // end of anonymous namespace


Fl_RGB_Image *get_icon_image(const std::string &name) {
	try {
		png_image_data D(get_icon_png(name));
		unsigned char *pixels = NULL;
		int w, h;
		load_png_ex(D.data, D.length, &pixels, &w, &h, 0);
		Fl_RGB_Image *I = new Fl_RGB_Image(pixels, w, h, 3);
		return I;
	} catch (std::string E) {
		unsigned char X[3] = {128, 128, 128};
		return new Fl_RGB_Image(X, 1, 1, 3);
	}
}
